
import java.net.*;
import java.lang.*;
import java.rmi.*;
import java.rmi.server.*;


// Cette classe implante l'entite qui va creer l'agent, l'envoyer
// sur le reseau et attendre son retour.
// Notez que cette classe est aussi une implantation de l'interface "Hote"
//
public class Initiateur extends UnicastRemoteObject
	implements Hote
	{


	static private boolean attendre = true;


	public Initiateur() throws RemoteException
	{
		super();
	}


	// La methode migre est un peu particuliere : elle ne 
	// declenche pas le traitement de l'agent mais 
	// lui demande d'afficher ses resultats
	//
	public void migre(Agent a) 
	{
		a.afficheResultat();
		attendre=false;
    	}


	public static void main(String args[]) 
	{
		if (System.getSecurityManager() == null) 
			System.setSecurityManager(new MySecurity());


		if (args.length < 3)
		{
			System.out.println("Au moins trois parametres : portRmiregistry produit hote {hote} ! ");
			System.exit(1);
		}


		try 
		{
			// Creation de l'objet et publication sur le 
			// reseau avec rmiregistry
			//
			Hote monInitiateur = new Initiateur();

                        MyHostName machine = new MyHostName();
                        String nom = "//" + machine.QualifiedHost() + ":" + args[0] + "/Initiateur";

			***

			System.out.println("Initiateur enregistre : " + nom);


			// Construction de la liste des hotes a
			// visiter (le site de l'initiateur est ajoute
			// en fin de liste de facon que l'agent revienne
			// chez l'initiateur en fin de traitement
			//
			String [] hotes = new String[20];
			int j=0;
			for(int i=2;i<args.length;i++)
				{
				MyHostName remote = new MyHostName(args[i]);
				hotes[j]=remote.QualifiedHost();
				j=j+1;
				}
			MyHostName locale = new MyHostName();
			hotes[j]= locale.QualifiedHost();


			// Creation de l'agentIngredient
			//
			agentIngredient agent = new agentIngredient(Integer.parseInt(args[0]), hotes, args[1],args.length-2);


			// Recherche du nom de service  du premier site 
			// a visiter + obtention d'un stub
			//
			String name = "//" + hotes[0] + ":" + args[0] + "/Hote";
			System.out.println("L'agent migre vers " + name);

			Hote hote  = (Hote) Naming.lookup(name);


			// Migration de l'agent
			//
			hote.migre(agent);


			// L'initiateur fait qq chose en attente du
			// de l'agent
			//
			while(attendre)
			{
				System.out.println("J'attends le resultat ...");
				try {Thread.sleep(100) ;} catch(Exception e) {};
			}

			System.out.println("Le resultat est arrive");
			System.exit(0);	

		} 
		catch (Exception e) 
		{
			System.err.println("migre exception: " + e.getMessage());
			e.printStackTrace();
		}
	}    
}


