
// Voila la classe qui implante l'agent que nous allons utiliser
// Comme tout implantation de l'interface "Agent",
// agentIngredient fournit trois methodes :
//   - hoteSuivant(). Cette methode permet a l'agent d'indiquer a 
//	l'hote qui l'heberge le site suivant a visiter.
//   - afficheResultat() qui affiche le resultat du traitement effectue
//	par notre agent
//   -  traitement() qui consiste a chercher dans le magasin de l'hote
//    	courant l'ingredient de prix minimal
//
public class agentIngredient implements Agent 
{


	// Ces trois attributs permettent a l'agent de
	// memoriser les hotes visites et ceux restant a l'etre.
	// Notre agent utilise pour ce faire une liste de sites
	// (attribut hotes) qui est consultee de facon sequentielle.
	// Un indice permet a l'agent de savoir quel est le prochain 
	// site a visiter
	// Noter la presence de l'attribut portRmiregistry qui donne 
	// le contexte de designation (acces au serveur de noms)
	//
	private String[] hotes = new String[20];
	private int hoteCourant = 0;
	private int nbHotes;
	private int portRmiregistry;


	// Recherche l'hote vers lequel l'agent
	// souhaite migrer
	//
	public String hoteSuivant()
	{
		// On passe au site suivant
		// (parcourt sequentiel de la liste des sites)
		//
		hoteCourant=hoteCourant+1;

		String nom=hotes[hoteCourant];

		if(hoteCourant==nbHotes)
			nom = "//" + nom + ":" + portRmiregistry + "/Initiateur";
		else  	nom = "//" + nom + ":" + portRmiregistry + "/Hote";


		return nom;
	}


	// Ces trois attributs constitue l'etat de l'agent
	// Ils stockent respectivement le prix minimal trouve,
	// le nom de l'ingredient a rechercher et le site sur 
	// lequel le prix minimum a ete trouve
	//
	private Float monPrix = new Float(Float.MAX_VALUE);
	private String monIngredient="";
	private String site="";

  
	// Comme son nom l'indique !!
	//
	public void afficheResultat()
	{
		System.out.println(site + " : le prix minimal de " + monIngredient + " est de " + monPrix );
	}
  

	// Constructeur de la classe
	//
	public agentIngredient(int p, String [] listeHotes, String ingredient, int nb)
	{
		monIngredient=ingredient;

		// Initialise la liste des sites a visiter
		//
		nbHotes=nb;
		for(int i=0; i<20; i++)
			hotes[i]=listeHotes[i];

	
		// Port de rmi-registry
		//
		portRmiregistry=p;
	}


	// Code du traitement effectue par notre agent
	// a chaque fois qu'il arrive sur un hote
	//
	public void traitement(String [] ingredient, Float [] prix, int taille)
	{
		// On recherche l'ingredient de prix minimal	
		// Notez que le resultat est stocke DANS l'agent
		// grace aux attributs "site" et "monPrix".
		// Faire migrer l'agent c'est donc faire migrer et le 
		// code du traitement, mais aussi les resultats intermediaires
		//
		for (int i=0; i<taille/2; i++)
			if (ingredient[i].equals(monIngredient))
				if(monPrix.floatValue() > prix[i].floatValue())
					{
						monPrix=prix[i];
						site=hotes[hoteCourant];
					}
	}

}
